#if !defined(TOOL_FLTBTNGA_H)
#define TOOL_FLTBTNGA_H

#if !defined(OWL_BUTTONGA_H)
# include <owl/buttonga.h>
#endif
#if !defined(OWL_GADGET_H)
# include <owl/gadget.h>
#endif
#if !defined(WINSYS_GEOMETRY_H)
# include <winsys/geometry.h>
#endif


//
// class TFlatButtonGadget
// ~~~~~ ~~~~~~~~~~~~~~~~~
//
class TFlatButtonGadget : public TButtonGadget {
  public:
    TFlatButtonGadget(TResId resId, int id, TType type = Command,
                      bool enabled = false, TState state = Up,
                      bool sharedGlyph = false);

  protected:
    void Paint      (TDC& dc);
    void PaintBorder(TDC& dc);

    void MouseEnter(uint modKeys, TPoint& point);
    void MouseLeave(uint modKeys, TPoint& point);

  private:
    bool mouseIsIn;

    TColor hotColor;
    TColor selectColor;

    void BuildMask(TDC& maskDC, const TPoint& maskDst, const TSize& maskSize,
                   TDC& glyphDC, const TRect& glyphRect);
    void DitherBackground(TDC& dc, TDC& maskDC, const TRect& dstRect);
    void PaintFace(TBitmap& glyph, TRect& srcRect, TDC& dc, TRect& faceRect,
                   TPoint& dstPoint);
};

//
// class TFlatSeparatorGadget
// ~~~~~ ~~~~~~~~~~~~~~~~~~~~
//
class TFlatSeparatorGadget : public TGadget {
  public:
    TFlatSeparatorGadget(int w = 0, int h = 0, int id = 0);

    void Inserted();

  protected:
    void Paint(TDC& dc);

    virtual void PaintHorizontally(TDC& dc);
    virtual void PaintVertically  (TDC& dc);

  private:
    int width;
    int height;

    void UpdateBounds(int w, int h);
};

//
// class TFlatGripperGadget
// ~~~~~ ~~~~~~~~~~~~~~~~~~
//
class TFlatGripperGadget : public TFlatSeparatorGadget {
  public:
    TFlatGripperGadget(int w = 0, int h = 0, int id = 0);

  protected:
    void MouseEnter(uint modKeys, TPoint& point);
    void MouseLeave(uint modKeys, TPoint& point);

    void LButtonDown(uint modKeys, TPoint& point);

    void PaintHorizontally(TDC& dc);
    void PaintVertically  (TDC& dc);
};

#endif  // TOOL_FLTBTNGA_H
