#include "msimg32.h"

// TMSImage32Module implementation
//
TMSImage32Module& TMSImage32Module::GetInstance()
{
  static TMSImage32Module Module;

  return Module;
}

TMSImage32Module::TMSImage32Module()
:
 TModule("msimg32.dll", true, true),
 AlphaBlend    (*this, "AlphaBlend"),
 GradientFill  (*this, "GradientFill"),
 TransparentBlt(*this, "TransparentBlt")
{
}
// TMSImage32Helper implementation
//
TMSImage32Helper::TMSImage32Helper(TMSImage32Module& module)
:
 Module(module)
{
}

void
TMSImage32Helper::DrawGradientRect(HDC dc, TRect& rect, TColor color1,
                                   TColor color2, ULONG mode)
{
  TRIVERTEX vertices[2];

  vertices[0].x     = rect.left;
  vertices[0].y     = rect.top;
  vertices[0].Red   = (COLOR16)(color1.Red  () << 8);
  vertices[0].Green = (COLOR16)(color1.Green() << 8);
  vertices[0].Blue  = (COLOR16)(color1.Blue () << 8);
  vertices[0].Alpha = 0x0000;

  vertices[1].x     = rect.right;
  vertices[1].y     = rect.bottom;
  vertices[1].Red   = (COLOR16)(color2.Red  () << 8);
  vertices[1].Green = (COLOR16)(color2.Green() << 8);
  vertices[1].Blue  = (COLOR16)(color2.Blue () << 8);
  vertices[1].Alpha = 0x0000;

  GRADIENT_RECT gRect;
  gRect.UpperLeft  = 0;
  gRect.LowerRight = 1;

  Module.GradientFill(dc, vertices, 2, &gRect, 1, mode);
}

void
TMSImage32Helper::DrawGradientRect(HDC dc, int left, int top, int right,
                                   int bottom, TColor color1, TColor color2,
                                   ULONG mode)
{
  TRIVERTEX vertices[2];

  vertices[0].x     = left;
  vertices[0].y     = top;
  vertices[0].Red   = (COLOR16)(color1.Red  () << 8);
  vertices[0].Green = (COLOR16)(color1.Green() << 8);
  vertices[0].Blue  = (COLOR16)(color1.Blue () << 8);
  vertices[0].Alpha = 0x0000;

  vertices[1].x     = right;
  vertices[1].y     = bottom;
  vertices[1].Red   = (COLOR16)(color2.Red  () << 8);
  vertices[1].Green = (COLOR16)(color2.Green() << 8);
  vertices[1].Blue  = (COLOR16)(color2.Blue () << 8);
  vertices[1].Alpha = 0x0000;

  GRADIENT_RECT gRect;
  gRect.UpperLeft  = 0;
  gRect.LowerRight = 1;

  Module.GradientFill(dc, vertices, 2, &gRect, 1, mode);
}

