#if !defined(TOOL_XPCTLBAR_H)
#define TOOL_XPCTLBAR_H

#if !defined(OWL_CONTROLB_H)
# include <owl/controlb.h>
#endif
#if !defined(OWL_DOCKING_H)
# include <owl/docking.h>
#endif

//
// class TXpControlBar
// ~~~~~ ~~~~~~~~~~~~~
//
class TXpControlBar : public TControlBar {
  public:
    TXpControlBar(TWindow* parent = 0, TTileDirection direction = Horizontal,
                  TFont* font = new TGadgetWindowFont, TModule* module = 0);

  protected:
    void Paint(TDC& dc, bool erase, TRect& rect);

    bool EvEraseBkgnd(HDC hDC);

  private:
    void PaintBackground(HDC hDC, TRect& rect);

  DECLARE_RESPONSE_TABLE(TXpControlBar);
};

//
// class TXpDockableControlBar
// ~~~~~ ~~~~~~~~~~~~~~~~~~~~~
//
class TXpDockableControlBar : public TDockableControlBar {
  public:
    TXpDockableControlBar(TWindow*        parent = 0,
                          TTileDirection  direction = Horizontal,
                          TFont*          font = new TGadgetWindowFont,
                          TModule*        module = 0);

  protected:
    void Paint(TDC& dc, bool erase, TRect& rect);

    bool EvEraseBkgnd(HDC hDC);

  private:
    void PaintBackgroundHorizontally(HDC hDC, TRect& rect);
    void PaintBackgroundVertically  (HDC hDC, TRect& rect);

    void PaintCorners(HDC hDC, TRect& rect, TColor color);

  DECLARE_RESPONSE_TABLE(TXpDockableControlBar);
};

#endif  // TOOL_XPCTLBAR_H
